Dir.glob(File.join(".", "lib", "**", "*.rb")).each { |f| require f }

module MkRepo
  module CLI
    REMOTES = %i(github gitlab bitbucket)

    def self.execute(opts, factory = Factory, validator = Validator)
      remote = opts.slice(*REMOTES).key(true)
      opts = validator.validate!(remote, opts)
      client = factory.build remote do
        token     opts[:token]
        repo_name opts[:repo]
        user      opts[:user]
      end

      client.create!
    rescue StandardError => e
      $stderr.puts e.message
    end
  end
end
