class Hash
  def slice(*keys)
    Hash[keys.zip(self.values_at(*keys))]
  end
end

class String
  def classify(*namespaces)
    Module.const_get(
      [*namespaces, self]
      .map(&:to_camel_case)
      .join("::")
    )
  end

  def to_camel_case
    split("_")
      .map(&:capitalize)
      .join
  end
end

class Symbol
  def classify(*namespaces)
    to_s.classify(*namespaces)
  end
end
